/* Encendre un Led amb el sensor d'ultrasons HC-SR04 utilitzant la llibreria New Ping
   El Led s'encén si l'objecte detectat està a menys de 10 cm                        
   Els ports utilitzats són: A0-trigger, A1-echo, 13-led                            */
 
#include <NewPing.h>                // Inclusió de la llibreria NewPing
                                  // Creació d'un objecte NewPing
NewPing sonar(A0, A1, 100);         // Creació de l'objecte "sonar" i configuració dels paràmetres per (trigger, echo, distancia_màxima)
                                  // Configuració de variables
int distancia;                      // Variable que emmagatzema la distància entre el sensor i un obstacle
int limit = 10;                     // Variable que emmagatzema la distància que volem que el LED s'encengui (a 10cm o menys)
unsigned int time;                  // Variable que emmagatzema el temps invertit entre el trigger i l'echo
                                  // Configuració de ports
int pinLed = 13;                    // Configuració del port del LED

void setup() 
{
  pinMode(pinLed, OUTPUT);          // Configuració del pin del Led com a OUTPUT (això es podria canviar per: pinMode(pinLed, 1);)
  Serial.begin(9600);               // Configuració de la connexió amb el Monitor Sèrie
}

void loop() 
{
  time = sonar.ping();                          // Time emmagatzema el temps que triga l'ona ultrasònica en anar i tornar
  distancia = time / US_ROUNDTRIP_CM;           // Conversió del temps emprat per l'ona ultrasònica en anar i tornar en cm
  Serial.print("Detectat un objecte a ");       // Presentació dels resultats en cm pel Monitor Sèrie
  Serial.print(distancia);
  Serial.println(" cm");
  if(distancia == 0) {                          // Per evitar els errors de lectura, si la distància llegida és 0...
    distancia = 100;                            // ...establim la distància màxima (100cm) i el led no s'encendrà
  }
  delay(500);                                  // Amb 10ms de retard n'hi hauria d'haver prou perquè el sensor faci tot el procés
  if(distancia < limit) {                       // Si troba algun objecte entre els 10 primers cm...
     digitalWrite(pinLed, HIGH);                // ...encén el LED
  }
  else {                                        // Si no...
     digitalWrite(pinLed, LOW);                 // ...apaga el LED
  }
}
